package aacs.decoder;

import aacs.math.AESFunc;

public class EVOBPack {

    public boolean isNavpack = false;
    public boolean isEncrypted = false;
    public boolean KEY_VF=false;

    public byte[] HeaderPart=new byte[128];
    public byte[] EncryptedPart=new byte[1920];
    public byte[] CPIField= new byte[16];
    public int titleKey=0;
    public int streamID=0;
    byte[] keySeed= new byte[16];


    public EVOBPack(byte[] rawData){
        System.arraycopy(rawData,0,HeaderPart,0,128);
        System.arraycopy(rawData,128,EncryptedPart,0,1920);

        streamID=rawData[0x11];
        if (streamID<0)streamID=streamID+256;

        int t =rawData[0x2c];
        if (t<0)t=t+256;
        int t2 =rawData[0x11];
        if (t2<0)t2=t2+256;

        if (rawData[0x2a]==0&&rawData[0x2b]==1&&t==0xbf&t2==0xbb){
            //This is a nav Pack
            isNavpack=true;
            isEncrypted=false;
            System.arraycopy(rawData,0x3c,CPIField,0,16);
            if ((CPIField[0]&128)!=0){
                KEY_VF=true;
                titleKey=CPIField[2];
            }

            // Fix for nav chain
            EncryptedPart[0x516-128]=15;    // todo!

            HeaderPart[0x3c]=0; // Clear CPI field
            HeaderPart[0x48]=0;

        }else{
            isNavpack=false;
            isEncrypted=false;
            int PES = rawData[20];
            if (PES<0)PES=PES+256;
            PES=PES>>>4;

            if ((PES&3)==1){
                isEncrypted=true;
                System.arraycopy(rawData,84,keySeed,0,4);
            }
        }
    }


    public void decryptPACK(byte[] TitleKey,byte[] CPIField){
        System.arraycopy(CPIField,4,keySeed,4,12);

        byte[] contentKey = AESFunc.AESG(TitleKey,keySeed);
        byte[] decrypted =AESFunc.decryptPack(EncryptedPart,contentKey);
        EncryptedPart=decrypted;
        HeaderPart[20]=(byte)(HeaderPart[20]&207); // Remove PES
    }

}
